Option Explicit



  Dim o
  Dim Link, LinkTemplate1, LinkTemplate2
  Set o = CreateObject("MSXML2.XMLHTTP")
  
  DIM LotData

  Dim ScriptControl
  Set ScriptControl = CreateObject("ScriptControl")
  ScriptControl.Language = "JScript"


	Dim pb
	Dim percentComplete
	'Setup the initial progress bar
	Set pb = New ProgressBar
	percentComplete = 0
	pb.SetTitle("  ")
	pb.SetText("...")
	pb.Show()
        pb.Update(percentComplete)


LinkTemplate1 = "http://maps.rosreestr.ru/arcgis/rest/services/Cadastre/CadastreSelected/MapServer/exts/GKNServiceExtension/online/parcel/find?cadNums=%5B%27" 
LinkTemplate2 = "%27%5D&onlyAttributes=false&returnGeometry=true&f=json&callback=dojo.io.script.jsonp_dojoIoScript25._jsonpCallback"


Dim objFSO, objFileLots, CadNum
Set objFSO = CreateObject("Scripting.FileSystemObject")
Set objFileLots = objFSO.OpenTextFile(objFSO.GetAbsolutePathName(".") & "\Lots.txt", 1)

Dim FileData
  Set FileData = objFSO.CreateTextFile(objFSO.GetAbsolutePathName(".") & "\LotsData.txt", True)

  FileData.WriteLine("cadastral_number" & vbTAB & "area" & vbTAB & "DATE_CREATE" & vbTAB & "date_change" & vbTAB & "cad_cost" & vbTAB & "date_cost" & vbTAB & "util_by_doc" & vbTAB & "util_code" & vbTAB & "category_type" & vbTAB & "object_address" & vbTAB & "parcel_status")
  
  Dim l, Count
  Dim Res
  
Do While objFileLots.AtEndOfStream = False
    CadNum = objFileLots.ReadLine
	
	Count = 10
	Res = True
	For l = 1 To Count
	  Res = GetData(CadNum)
      If (Res = true) then
	      FileData.WriteLine(LotData)
    		Exit For
      End If
	Next
	
	If (l >= Count) Then
	  MsgBox("  ")
	  WScript.Quit
	End If
	
	
    If (objFileLots.Line mod 10) = 0 Then
      pb.Update(percentComplete)
      pb.SetText(" #" & objFileLots.Line & ": " & CadNum)
      percentComplete = objFileLots.Line mod 100
'      percentComplete = objFileLots.Line
    End If
Loop

FileData.Close
pb.Close
WScript.Echo "Done"
WScript.Quit

Function GetData(ByRef CadNum)
  Dim Link
  Link = LinkTemplate1 & Replace(CadNum, ":", "%3A") & LinkTemplate2
  o.open "POST", Link, False
  o.send


  Dim JSON_Str, JSON
  JSON_Str = o.responseText
  JSON_Str = Replace(JSON_Str, "dojo.io.script.jsonp_dojoIoScript25._jsonpCallback(",  " ")
  JSON_Str = Replace(JSON_Str, ");", " ")


  Dim tmp
  
  On Error resume next
  
	LotData = ""

    Set JSON = ScriptControl.Eval( "(" & JSON_Str & ")" )

    For Each tmp in JSON.features
      LotData = tmp.attributes.PARCEL_CN & vbTAB & Replace(tmp.attributes.AREA_VALUE, ",", ".") & vbTAB & unUDate(tmp.attributes.DATE_CREATE) & vbTAB & unUDate(tmp.attributes.ACTUAL_DATE) & Replace(vbTAB & tmp.attributes.CAD_COST, ",", ".") & vbTAB & unUDate(tmp.attributes.DATE_COST) & vbTAB & tmp.attributes.UTIL_BY_DOC & vbTAB & tmp.attributes.UTIL_CODE & vbTAB & tmp.attributes.CATEGORY_TYPE & vbTAB & tmp.attributes.OBJECT_ADDRESS & vbTAB & tmp.attributes.PARCEL_STATUS
    Next
  
  If Err.Number <> 0 Then
    GetData = false
  Else
    GetData = true
  End If  
  
  On Error goto 0
End Function 

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    function UDate(oldDate)
	    UDate = DateDiff("s", "01/01/1970 00:00:00", oldDate)
    end function

    function unUDate(intTimeStamp)
      If (intTimeStamp <> "") AND (intTimeStamp > 0) Then
	unUDate = DateAdd("s", intTimeStamp/1000, "01/01/1970 00:00:00")
      Else 
	unUDate = "-"
      End If
    end function

''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Class ProgressBar
Private m_PercentComplete
Private m_CurrentStep
Private m_ProgressBar
Private m_Title
Private m_Text
Private m_StatusBarText
 
'Initialize defaults
Private Sub ProgessBar_Initialize
m_PercentComplete = 0
m_CurrentStep = 0
m_Title = "Progress"
m_Text = ""
End Sub
 
Public Function SetTitle(pTitle)
m_Title = pTitle
End Function
 
Public Function SetText(pText)
m_Text = pText
End Function
 
Public Function Update(percentComplete)
m_PercentComplete = percentComplete
UpdateProgressBar()
End Function
 
Public Function Show()
Set m_ProgressBar = CreateObject("InternetExplorer.Application")
'in code, the colon acts as a line feed
m_ProgressBar.navigate2 "about:blank" : m_ProgressBar.width = 500 : m_ProgressBar.height = 100 : m_ProgressBar.toolbar = false : m_ProgressBar.menubar = false : m_ProgressBar.statusbar = false : m_ProgressBar.visible = True
m_ProgressBar.document.write "<body Scroll=no style='margin:0px;padding:0px;'><div style='text-align:center;'><span name='pc' id='pc'>0</span></div>"
m_ProgressBar.document.write "<div id='statusbar' name='statusbar' style='border:1px solid blue;line-height:12px;height:15px;color:red;'></div>"
m_ProgressBar.document.write "<div style='text-align:center'><span id='text' name='text'></span></div>"
End Function
 
Public Function Close()
m_ProgressBar.quit
'm_ProgressBar = Nothing
End Function
 
Private Function UpdateProgressBar()
If m_PercentComplete = 0 Then
m_StatusBarText = ""
End If
Dim n
'	For n = m_CurrentStep to m_PercentComplete - 1
'		m_StatusBarText = m_StatusBarText & "|"
'		m_ProgressBar.Document.GetElementById("statusbar").InnerHtml = m_StatusBarText
'		m_ProgressBar.Document.title = n & "% Complete : " & m_Title
'		m_ProgressBar.Document.GetElementById("pc").InnerHtml = n & "% Complete : " & m_Title
'		wscript.sleep 10
'	Next
m_StatusBarText = m_StatusBarText & ""
m_ProgressBar.Document.GetElementById("statusbar").InnerHtml = m_StatusBarText
m_ProgressBar.Document.title = m_PercentComplete & "% Complete : " & m_Title
m_ProgressBar.Document.GetElementById("pc").InnerHtml = m_PercentComplete & "% Complete : " & m_Title
m_ProgressBar.Document.GetElementById("text").InnerHtml = m_Text
m_CurrentStep = m_PercentComplete
End Function
 
End Class